<template>

  <Head>
    <title>Add New Product - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow">
              <!-- text header -->
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-shopping-bag me-2"></i> ADD NEW PRODUCT</span>
              </div>
              <div class="card-body">
                <!--form create product -->
                <form @submit.prevent="submit">
                  <!-- image -->
                  <div class="mb-3">
                    <label for="image" class="fw-bold">Image</label>
                    <input class="form-control" @input="form.image = $event.target.files[0]"
                      :class="{ 'is-invalid': errors.image }" type="file" id="image">
                  </div>
                  <div v-if="errors.image" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.image }}</strong></small>
                  </div>

                  <!-- barcode -->
                  <div class="mb-3">
                    <label for="barcode" class="fw-bold">Barcode</label>
                    <input class="form-control" v-model="form.barcode" :class="{ 'is-invalid': errors.barcode }"
                      type="text" id="barcode" placeholder="Barcode / Code Product" maxlength="12">
                  </div>
                  <div v-if="errors.barcode" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.barcode }}</strong></small>
                  </div>

                  <!-- category -->
                  <div class="mb-3">
                    <label for="category" class="fw-bold">Category</label>
                    <select class="form-select" :class="{ 'is-invalid': errors.category_id }" v-model="form.category_id"
                      id="category">
                      <option v-for="(category, index) in categories" :key="index" :value="category.id">{{
                        category.name
                      }}</option>
                    </select>
                  </div>
                  <div v-if="errors.category_id" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.category_id }}</strong></small>
                  </div>

                  <!-- product name -->
                  <div class="mb-3">
                    <label for="name" class="fw-bold">Product Name</label>
                    <input class="form-control" v-model="form.name" :class="{ 'is-invalid': errors.name }" type="text"
                      id="name" placeholder="Product Name">
                  </div>
                  <div v-if="errors.name" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.name }}</strong></small>
                  </div>

                  <!-- stock -->
                  <div class="mb-3">
                    <label for="stock" class="fw-bold">Stock</label>
                    <input class="form-control" v-model="form.stock" :class="{ 'is-invalid': errors.stock }"
                      type="number" id="stock" placeholder="Stock">
                  </div>
                  <div v-if="errors.stock" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.stock }}</strong></small>
                  </div>

                  <!-- description -->
                  <div class="mb-3">
                    <label for="description" class="fw-bold">Description</label>
                    <textarea class="form-control" v-model="form.description"
                      :class="{ 'is-invalid': errors.description }" rows="4" id="description"
                      placeholder="Description"></textarea>
                  </div>
                  <div v-if="errors.description" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.description }}</strong></small>
                  </div>

                  <!-- buy price -->
                  <div class="mb-3">
                    <label for="buy_price" class="fw-bold">Buy Price</label>
                    <input class="form-control" v-model="form.buy_price" :class="{ 'is-invalid': errors.buy_price }"
                      type="number" id="buy_price" placeholder="Buy Price">
                  </div>
                  <div v-if="errors.buy_price" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.buy_price }}</strong></small>
                  </div>

                  <!-- sell price -->
                  <div class="mb-3">
                    <label for="sell_price" class="fw-bold">Sell Price</label>
                    <input class="form-control" v-model="form.sell_price" :class="{ 'is-invalid': errors.sell_price }"
                      type="number" id="sell_price" placeholder="Sell Price">
                  </div>
                  <div v-if="errors.sell_price" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.sell_price }}</strong></small>
                  </div>

                  <!-- button submit -->
                  <div class="row">
                    <div class="col-12">
                      <button class="btn btn-primary shadow-sm rounded" type="submit">
                        Save
                      </button>
                    </div>
                  </div>
                </form>

              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue';

// import head and link from inertia
import { Head, Link } from '@inertiajs/vue3';

// import reactive from vue
import { reactive } from 'vue';

// import router adapter
import { router } from '@inertiajs/vue3';

// import sweet alert2
import Swal from 'sweetalert2';

export default {
  // layout
  layout: LayoutApp,

  // register components
  components: {
    Head,
    Link
  },

  // props
  props: {
    errors: Object,
    categories: Array
  },

  // composition api
  setup() {

    // define form with reactive
    const form = reactive({
      image: '',
      barcode: '',
      category_id: '',
      name: '',
      description: '',
      buy_price: '',
      sell_price: '',
      stock: ''
    });

    // define method "submit"
    const submit = () => {

      // send data to server
      router.post('/apps/products', form, {
        onSuccess: () => {
          // show success alert
          Swal.fire({
            title: 'Created!',
            text: 'Product has been created.',
            icon: 'success',
            showConfirmButton: false,
            timer: 2000
          });
        },
      });
    }

    // return
    return {
      form,
      submit,
    }
  }
}
</script>

<style>

</style>